#include <iostream>
#include <vector>
#include <cmath>
#include "histogram.h"
using namespace std;


void find_minmax(const vector<double>& numbers, double& mini, double& maxi) {

    mini = numbers[0];
    maxi = numbers[0];
    for (double x : numbers) {
        if (x < mini) {
            mini = x;
        }
        else if (x > maxi) {
            maxi = x;
        }
    }
}
vector<size_t>
make_histogram(const vector<double>& numbers, size_t bin_count) {
    double mini, maxi;
    find_minmax(numbers, mini, maxi);

    vector<size_t> bins(bin_count);

    double bin_size = (maxi - mini) / bin_count;
    for (double num : numbers) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++){
            auto lo = mini + j * bin_size;
            auto hi = mini + (j + 1) * bin_size;
            if ((lo <= num) && (num < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    return bins;
}
