#define DOCTEST_CONFIG_NO_MULTITHREADING
#define DOCTEST_CONFIG_IMPLEMENT_WITH_MAIN
#include "doctest.h"
#include "histogram_internal.h"
#include "svg_internal.h"

TEST_CASE("distinct positive numbers") {
    double mini = 0;
    double maxi = 0;
    find_minmax({1, 2}, mini, maxi);
    CHECK(mini == 1);
    CHECK(maxi == 2);
}

TEST_CASE("empty vector") {
    double mini = 0;
    double maxi = 0;
    find_minmax({1, 2}, mini, maxi);
    CHECK(mini == 1);
    CHECK(maxi == 2);
}

TEST_CASE("vector with one element") {
    double mini = 0;
    double maxi = 0;
    find_minmax({1}, mini, maxi);
    CHECK(mini == 1);
    CHECK(maxi == 1);
}

TEST_CASE("vector with negative elements") {
    double mini = 0;
    double maxi = 0;
    find_minmax({-1, -2}, mini, maxi);
    CHECK(mini == -2);
    CHECK(maxi == -1);
}

TEST_CASE("vector with equivalent elements") {
    double mini = 0;
    double maxi = 0;
    find_minmax({2, 2}, mini, maxi);
    CHECK(mini == 2);
    CHECK(maxi == 2);
}

TEST_CASE("vector with 0") {
    double mini = 0;
    double maxi = 0;
    find_minmax({0, 0}, mini, maxi);
    CHECK(mini == 0);
    CHECK(maxi == 0);
}

TEST_CASE("vector with fractional numbers") {
    double mini = 0;
    double maxi = 0;
    find_minmax({2.4, 2.2}, mini, maxi);
    CHECK(mini == 2.2);
    CHECK(maxi == 2.4);
}

TEST_CASE("20") {
    double BLOCK_WIDTH = 0;
    BLOCK_WIDTH = get_block_width();
    CHECK(BLOCK_WIDTH == 20);
}

TEST_CASE("4.5") {
    double BLOCK_WIDTH = 0;
    BLOCK_WIDTH = get_block_width();
    CHECK(BLOCK_WIDTH == 4.5);
}

TEST_CASE("-1") {
    double BLOCK_WIDTH = 0;
    BLOCK_WIDTH = get_block_width();
    CHECK(BLOCK_WIDTH == -1);
}
